SystemOrganization addCategory: #'GT-EventRecorder'!
SystemOrganization addCategory: 'GT-EventRecorder-Announcements'!
SystemOrganization addCategory: 'GT-EventRecorder-Core'!
SystemOrganization addCategory: 'GT-EventRecorder-Identifier'!
SystemOrganization addCategory: 'GT-EventRecorder-Privacy'!
SystemOrganization addCategory: 'GT-EventRecorder-Settings'!

Announcement subclass: #GTEventAnnouncement
	instanceVariableNames: 'dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Announcements'!

!GTEventAnnouncement class methodsFor: 'examples' stamp: 'JurajKubelka 10/11/2015 14:26'!
gtExampleAnnouncement
	<gtExample>
	^ self new
			data: #[ 1 2 3 4 ];
			timestamp: DateAndTime now;
			imageHash: SmalltalkImage current imagePath hash;
			sessionCreationTime: SmalltalkImage current session creationTime;
			imageVersion: SystemVersion current version;
			latestUpdate: SystemVersion current highestUpdate;
			yourself! !

!GTEventAnnouncement class methodsFor: 'examples' stamp: 'JurajKubelka 10/9/2015 15:26'!
gtExampleEmptyAnnouncement
	<gtExample>
	^ self new! !

!GTEventAnnouncement methodsFor: 'updating' stamp: 'JurajKubelka 10/9/2015 15:26'!
addInfoFor: aGTSpotterRecorderEvent 
	dictionary keysAndValuesDo: [ :key :value |
		key = #data ifFalse: [ 
			aGTSpotterRecorderEvent infoAt: key put: value ] ]! !

!GTEventAnnouncement methodsFor: 'converting' stamp: 'JurajKubelka 10/9/2015 15:26'!
associations
	^ dictionary 
			ifNil: [ #() ]
			ifNotNil: [ dictionary associations ]! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:26'!
at: key
	^ self dictionary at: key ifAbsent: [ nil ]! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:26'!
at: key put: value
	^ self dictionary at: key put: value! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:26'!
computerUUID
	^ self at: #computerUUID! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:26'!
computerUUID: anObject
	self at: #computerUUID put: anObject! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:26'!
data
	^ self at: #data! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:26'!
data: aByteArray 
	self at: #data put: aByteArray! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:26'!
dictionary
	^ dictionary ifNil: [ dictionary := Dictionary new ]! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:26'!
eventRecorderVersion
	^ self at: #eventRecorderVersion! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:26'!
eventRecorderVersion: anObject
	self at: #eventRecorderVersion put: anObject! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:26'!
events
	| events |
	events := self materializedData.
	events do: [ :each | self addInfoFor: each ].
	^ events! !

!GTEventAnnouncement methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 10/9/2015 15:26'!
gtInspectorItems
	^ OrderedCollection withAll: self associations! !

!GTEventAnnouncement methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 10/9/2015 15:26'!
gtInspectorItemsIn: composite
	<gtInspectorPresentationOrder: -1>  
	^ (composite table)
		title: 'Info';
		display: [ :anEvent | anEvent gtInspectorItems ];
		children: [ :each | 
			(each value isDictionary) 
				ifTrue: [ each value associations ] 
				ifFalse: [ (each value isArray and: [ each value allSatisfy: #isDictionary ])
						ifTrue: [ each value collectWithIndex: [:x :i | i -> x ] ]
						ifFalse: [ #() ] ] ];
		column: 'Key' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each key ];
		column: 'Value' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each value ];
		showOnly: 50! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:26'!
imageHash
	^ self at: #imageHash! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:26'!
imageHash: anObject
	self at: #imageHash put: anObject! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:26'!
imageVersion
	^ self at: #imageVersion! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:26'!
imageVersion: anObject
	self at: #imageVersion put: anObject! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:26'!
latestUpdate
	^ self at: #latestUpdate! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:26'!
latestUpdate: anObject
	self at: #latestUpdate put: anObject! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/10/2015 15:31'!
serializedBy
	^ self dictionary at: #serializedBy ifAbsent: [ GTFuelPacking name ]! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/10/2015 15:16'!
serializedBy: anObject
	self at: #serializedBy put: anObject! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:26'!
sessionCreationTime
	^ self at: #sessionCreationTime! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:26'!
sessionCreationTime: anObject
	self at: #sessionCreationTime put: anObject! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:28'!
sessionUUID
	^ self at: #sessionUUID! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:28'!
sessionUUID: anObject
	self at: #sessionUUID put: anObject! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:26'!
timestamp
	^ self at: #timestamp! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:26'!
timestamp: anObject
	self at: #timestamp put: anObject! !

!GTEventAnnouncement methodsFor: 'accessing' stamp: 'JurajKubelka 10/10/2015 15:27'!
unpackedData
	^ self data ifNotNil: [ :aData | 	self serializedBy asClass new materialize: aData ]! !

Announcement subclass: #GTEventInternalAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Announcements'!

GTEventInternalAnnouncement subclass: #GTEventSuspendingDeliveryAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Announcements'!

Object subclass: #GTEventBundle
	instanceVariableNames: 'url data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Core'!

!GTEventBundle methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:56'!
data
	^ data! !

!GTEventBundle methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:56'!
data: anObject
	data := anObject! !

!GTEventBundle methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:56'!
url
	^ url! !

!GTEventBundle methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:56'!
url: anObject
	url := anObject! !

Object subclass: #GTEventCollector
	instanceVariableNames: 'url recordedEvents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Core'!

GTEventCollector class
	instanceVariableNames: 'uniqueInstance'!

GTEventCollector class
	instanceVariableNames: 'uniqueInstance'!

!GTEventCollector class methodsFor: 'cleanup' stamp: 'JurajKubelka 10/11/2015 14:45'!
cleanUp
	self reset.! !

!GTEventCollector class methodsFor: 'initialization' stamp: 'JurajKubelka 10/11/2015 14:39'!
initializeUniqueInstance
	uniqueInstance ifNotNil: [ self reset ].
	uniqueInstance := self new.
	GTEventRecorder uniqueInstance addCollector: uniqueInstance! !

!GTEventCollector class methodsFor: 'accessing' stamp: 'JurajKubelka 10/11/2015 14:40'!
reset
	uniqueInstance ifNil: [ ^ self ].
	GTEventRecorder uniqueInstance removeCollector: uniqueInstance.
	uniqueInstance := nil.! !

!GTEventCollector class methodsFor: 'accessing' stamp: 'JurajKubelka 10/11/2015 14:37'!
uniqueInstance
	uniqueInstance ifNil: [ self initializeUniqueInstance ].
	^ uniqueInstance! !

!GTEventCollector methodsFor: 'adding' stamp: 'JurajKubelka 10/9/2015 12:14'!
add: anEvent 
	^ recordedEvents nextPut: anEvent! !

!GTEventCollector methodsFor: 'accessing' stamp: 'JurajKubelka 10/11/2015 13:59'!
bundle
	^ self bundle: OrderedCollection new.! !

!GTEventCollector methodsFor: 'accessing' stamp: 'JurajKubelka 10/11/2015 13:58'!
bundle: aCollection
	recordedEvents flush: [ :eachEvent | aCollection addLast: eachEvent ].
	^ aCollection! !

!GTEventCollector methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 14:56'!
flush
	recordedEvents flush! !

!GTEventCollector methodsFor: 'initialization' stamp: 'JurajKubelka 10/9/2015 12:12'!
initialize
	super initialize.	
	recordedEvents := WaitfreeQueue new.
! !

!GTEventCollector methodsFor: 'printing' stamp: 'JurajKubelka 10/11/2015 19:50'!
printOn: aStream
	super printOn: aStream.
	aStream
		space;
		nextPut: $[;
		print: recordedEvents size;
		space;
		nextPutAll: ('item' asPluralBasedOn: recordedEvents size);
		nextPut: $]! !

!GTEventCollector methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 12:12'!
size
	^ recordedEvents size! !

!GTEventCollector methodsFor: 'accessing' stamp: 'JurajKubelka 10/11/2015 14:20'!
url
	^ url ifNil: [ url := GTEventRecorderSettings url ]! !

!GTEventCollector methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 12:06'!
url: anObject
	url := anObject! !

Object subclass: #GTEventCollectors
	instanceVariableNames: 'mutex collectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Core'!

!GTEventCollectors methodsFor: 'adding' stamp: 'JurajKubelka 10/9/2015 10:25'!
add: aGTEventCollector
	^ mutex critical: [ collectors addLast: aGTEventCollector ]! !

!GTEventCollectors methodsFor: 'enumerating' stamp: 'JurajKubelka 10/9/2015 14:55'!
do: oneArgBlock
	mutex critical: [ collectors do: oneArgBlock ]! !

!GTEventCollectors methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 10/9/2015 16:38'!
gtInspectorItemsIn: composite
	<gtInspectorPresentationOrder: 1>
	^ collectors ifNotNil: [ 
			(collectors gtInspectorItemsIn: composite)
				title: 'Collectors' ]! !

!GTEventCollectors methodsFor: 'initialization' stamp: 'JurajKubelka 10/9/2015 10:26'!
initialize
	super initialize.
	mutex := Mutex new.
	collectors := OrderedCollection new.! !

!GTEventCollectors methodsFor: 'accessing' stamp: 'JurajKubelka 10/11/2015 15:49'!
numberOfEvents
	^ mutex critical: [ 
		collectors 
			ifEmpty: 0
			ifNotEmpty: [ collectors sum: #size ] ]! !

!GTEventCollectors methodsFor: 'printing' stamp: 'JurajKubelka 10/11/2015 19:52'!
printOn: aStream
	super printOn: aStream.
	aStream
		space;
		nextPut: $[;
		print: self size;
		space;
		nextPutAll: ('collector' asPluralBasedOn: self size);
		nextPutAll: ', ';
		print: self numberOfEvents;
		space;
		nextPutAll: ('event' asPluralBasedOn: self numberOfEvents);
		nextPut: $]! !

!GTEventCollectors methodsFor: 'removing' stamp: 'JurajKubelka 10/11/2015 15:57'!
remove: aGTEventCollector 
	^ mutex critical: [ collectors remove: aGTEventCollector ifAbsent: nil ]! !

!GTEventCollectors methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 10:33'!
size
	^ mutex critical: [ collectors size ]! !

Object subclass: #GTEventDelivery
	instanceVariableNames: 'mutex process delay permission recorder queue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Core'!

!GTEventDelivery methodsFor: 'activation' stamp: 'JurajKubelka 10/9/2015 21:04'!
activate
	"Initialize a delivery process if permitted and necessary."
	^ mutex critical: [ 
			self hasPermission ifFalse: [ ^ self ].
			self isInactive ifTrue: [ self initializeProcess ].
			process ]! !

!GTEventDelivery methodsFor: 'adding' stamp: 'JurajKubelka 10/9/2015 12:46'!
add: packByteArray
	queue nextPut: packByteArray! !

!GTEventDelivery methodsFor: 'announce' stamp: 'JurajKubelka 10/11/2015 20:18'!
announceSuspendingDelivery
	self announcer ifNotNil: [ :anAnnoucner | anAnnoucner announce: GTEventSuspendingDeliveryAnnouncement ]! !

!GTEventDelivery methodsFor: 'accessing' stamp: 'JurajKubelka 10/11/2015 20:18'!
announcer
	^ self recorder ifNotNil: #announcer! !

!GTEventDelivery methodsFor: 'deactivation' stamp: 'JurajKubelka 10/9/2015 11:27'!
deactivate
	^ mutex critical: [ | oldProcess |
		self withdrawPermission.
		delay ifNotNil: [ :aDelay | aDelay delaySemaphore signal ].
		oldProcess := process.
		process := nil.
		oldProcess ]! !

!GTEventDelivery methodsFor: 'delivery' stamp: 'JurajKubelka 10/9/2015 12:25'!
deliver: aBoolean
	queue flush: [ :eachByteArray |
		self deliver: eachByteArray signalProgress: aBoolean ]! !

!GTEventDelivery methodsFor: 'delivery' stamp: 'JurajKubelka 10/9/2015 16:29'!
deliver: aGTEventBundle signalProgress: aBoolean
	^ (ZnClient new
			beOneShot;
			timeout: 5;
			signalProgress: aBoolean;
			numberOfRetries: 0;
			url: aGTEventBundle url;
			enforceHttpSuccess: true;
			ifFail: [ :exception | queue nextPut: aGTEventBundle ];
			entity: (ZnByteArrayEntity bytes: aGTEventBundle data);
			put;
			response)! !

!GTEventDelivery methodsFor: 'initialization' stamp: 'JurajKubelka 10/9/2015 21:17'!
deliveryCycle
	delay := self standardDuration asDelay.
	self announceSuspendingDelivery.
	delay wait.
	delay := nil.
	self hasPermission ifTrue: [ self packAndDeliver: false ]! !

!GTEventDelivery methodsFor: 'testing' stamp: 'JurajKubelka 10/9/2015 11:16'!
hasPermission
	^ permission! !

!GTEventDelivery methodsFor: 'initialization' stamp: 'JurajKubelka 10/9/2015 12:21'!
initialize
	super initialize.
	mutex := Mutex new.
	queue := WaitfreeQueue new.
	permission := true.! !

!GTEventDelivery methodsFor: 'initialization' stamp: 'JurajKubelka 10/11/2015 16:13'!
initializeProcess
	process := [ [ self hasPermission ] whileTrue: [ self deliveryCycle ] ]
		forkAt: Processor userBackgroundPriority
		named: self printProcessName! !

!GTEventDelivery methodsFor: 'testing' stamp: 'JurajKubelka 10/9/2015 10:53'!
isActive
	^ self isInactive not! !

!GTEventDelivery methodsFor: 'testing' stamp: 'JurajKubelka 10/11/2015 16:15'!
isGlobalRecorder
	^ self recorder 
			ifNil: false
			ifNotNil: #isGlobalRecorder! !

!GTEventDelivery methodsFor: 'testing' stamp: 'JurajKubelka 10/9/2015 20:56'!
isInactive
	^ mutex critical: [ 
		process isNil or: [
			process isTerminated or: [
				process isTerminating ] ] ]! !

!GTEventDelivery methodsFor: 'delivery' stamp: 'JurajKubelka 10/9/2015 11:30'!
now
	"for testing purpose"
	delay ifNotNil: [ :aDelay | aDelay delaySemaphore signal. aDelay unschedule. ]! !

!GTEventDelivery methodsFor: 'activation' stamp: 'JurajKubelka 10/9/2015 11:23'!
offerPermission
	mutex critical: [ permission := true ]! !

!GTEventDelivery methodsFor: 'delivery' stamp: 'JurajKubelka 10/9/2015 12:24'!
packAndDeliver: aBoolean.
	recorder pack.
	self deliver: aBoolean.
	! !

!GTEventDelivery methodsFor: 'printing' stamp: 'JurajKubelka 10/11/2015 20:24'!
printOn: aStream
	super printOn: aStream.
	aStream
		space;
		nextPut: $[;
		print: queue size;
		space;
		nextPutAll: ('item' asPluralBasedOn: queue size).
	self isActive
		ifTrue: [ 
			delay 
				ifNil: [ aStream nextPutAll: 'process active, but delay is nil!!' ]
				ifNotNil: [ :aDelay |
					aStream
						nextPutAll: ', next cycle in ';
						print: (aDelay millisecondsToGo milliSeconds roundTo: 1 second);
						nextPutAll: ' sec' ] ]
		ifFalse: [ 
			aStream nextPutAll: ', inactive' ].
	aStream		
		nextPut: $]! !

!GTEventDelivery methodsFor: 'printing' stamp: 'JurajKubelka 10/11/2015 16:13'!
printProcessName
	^ String streamContents: [ :aStream |
		self printProcessNameOn: aStream ]! !

!GTEventDelivery methodsFor: 'printing' stamp: 'JurajKubelka 10/11/2015 16:13'!
printProcessNameOn: aStream
	aStream
		nextPutAll: self className.
	self isGlobalRecorder
		ifTrue: [ aStream nextPutAll: ' global ' ]
		ifFalse: [ aStream nextPutAll: ' a ' ].
	aStream nextPutAll: 'delivery process'! !

!GTEventDelivery methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 12:20'!
recorder
	^ recorder! !

!GTEventDelivery methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 12:20'!
recorder: anObject
	recorder := anObject! !

!GTEventDelivery methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:46'!
size
	^ queue size! !

!GTEventDelivery methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 11:11'!
standardDuration
	^ 20 minutes! !

!GTEventDelivery methodsFor: 'deactivation' stamp: 'JurajKubelka 10/9/2015 11:23'!
withdrawPermission
	mutex critical: [ permission := false ]! !

Object subclass: #GTEventPacking
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Core'!

!GTEventPacking class methodsFor: 'instance creation' stamp: 'JurajKubelka 10/10/2015 15:19'!
fuel
	^ GTFuelPacking new! !

!GTEventPacking class methodsFor: 'instance creation' stamp: 'JurajKubelka 10/10/2015 15:19'!
ston
	^ GTStonPacking new! !

!GTEventPacking methodsFor: 'packing' stamp: 'JurajKubelka 10/10/2015 15:15'!
announcementWith: aByteArray
	^ GTEventAnnouncement new
			data: aByteArray;
			serializedBy: self class name;
			eventRecorderVersion: self version;
			timestamp: DateAndTime now;
			imageHash: SmalltalkImage current imagePath hash;
			imageVersion: SystemVersion current version;
			latestUpdate: SystemVersion current highestUpdate;
			computerUUID: GlobalIdentifier uniqueInstance computerUUID asString;
			sessionUUID: SmalltalkImage current session sid;
			sessionCreationTime: SmalltalkImage current session creationTime;
			yourself			! !

!GTEventPacking methodsFor: 'private' stamp: 'JurajKubelka 10/10/2015 15:17'!
materialize: aByteArray
	^ self subclassResponsibility! !

!GTEventPacking methodsFor: 'packing' stamp: 'JurajKubelka 10/9/2015 16:23'!
pack: aGTEventCollector
	^ GTEventBundle new
			url: aGTEventCollector url;
			data: (self packEvents: aGTEventCollector bundle);
			yourself! !

!GTEventPacking methodsFor: 'packing' stamp: 'JurajKubelka 10/9/2015 16:23'!
packEvents: aCollectionOfEvents
	^ self serialize: (self announcementWith: (self serialize: aCollectionOfEvents))! !

!GTEventPacking methodsFor: 'private' stamp: 'JurajKubelka 10/10/2015 15:18'!
serialize: anObject
	^ self subclassResponsibility! !

!GTEventPacking methodsFor: 'packing' stamp: 'JurajKubelka 10/9/2015 15:38'!
unpack: aByteArray
	^ self materialize: aByteArray! !

!GTEventPacking methodsFor: 'accessing' stamp: 'JurajKubelka 10/10/2015 15:13'!
version
	^ 3
	
"Changes to version 3:
	- GTSpotterEventRecorder rewritten to GTEventRecorder.
	- It uses STON instead of FUEL serializing engine.
		- FUEL engine is still available using GTFuelPacking object
Changes to version 2 (FUEL):
	- GTSpotterEventRecorder>>timestamp keeps DateAndTime object. 
	  Before, it was an integer as unix time.
"! !

GTEventPacking subclass: #GTFuelPacking
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Core'!

!GTFuelPacking methodsFor: 'private' stamp: 'JurajKubelka 10/10/2015 15:08'!
materialize: aByteArray
	| materializer stream gzstream materialization |
	stream := aByteArray readStream. 
	gzstream := GZipReadStream on: stream.
	materializer := FLMaterializer newDefault.
	materialization := materializer materializeFrom: gzstream.
	gzstream close.
	stream close.
	^ materialization root.! !

!GTFuelPacking methodsFor: 'private' stamp: 'JurajKubelka 10/10/2015 15:08'!
serialize: anObject
	| serializer stream gzstream |
	stream := ByteArray new writeStream binary. 
	gzstream := GZipWriteStream on: stream.
	serializer := FLSerializer newDefault.
	serializer at: #recorderVersion putAdditionalObject: self version.
	serializer stream: gzstream.
	serializer serialize: anObject.
	gzstream close.
	stream close.
	^ stream contents.! !

GTEventPacking subclass: #GTStonPacking
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Core'!

!GTStonPacking methodsFor: 'private' stamp: 'JurajKubelka 10/10/2015 15:42'!
materialize: aByteArray
	| stream gzstream |
	stream := aByteArray readStream. 
	gzstream := GZipReadStream on: stream.
	^ [ STON fromStream: gzstream ] ensure: [ gzstream close. stream close ]! !

!GTStonPacking methodsFor: 'private' stamp: 'JurajKubelka 10/10/2015 15:45'!
serialize: anObject
	^ String streamContents: [ :stream | | gzstream |
		gzstream := GZipWriteStream on: stream.
		[ STON put: anObject onStreamPretty: gzstream ]
			ensure: [ gzstream close ] ]! !

Object subclass: #GTEventRecorder
	instanceVariableNames: 'collectors delivery packing privacy announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Core'!

GTEventRecorder class
	instanceVariableNames: 'uniqueInstance'!

GTEventRecorder class
	instanceVariableNames: 'uniqueInstance'!

!GTEventRecorder class methodsFor: 'cleanup' stamp: 'JurajKubelka 10/11/2015 14:45'!
cleanUp
	self reset.! !

!GTEventRecorder class methodsFor: 'testing' stamp: 'JurajKubelka 10/11/2015 16:16'!
isGlobalRecorder: aGTEventRecorder
	^ uniqueInstance 
			ifNil: false
			ifNotNil: [ :anInstance | anInstance == aGTEventRecorder  ]! !

!GTEventRecorder class methodsFor: 'accessing' stamp: 'JurajKubelka 10/11/2015 14:45'!
reset
	"Stop and remove the process for sending usage data. Delete all recorder that from the queue."
	uniqueInstance ifNil: [ ^ self ].
	uniqueInstance deactivateDelivery ifNotNil: [ :aProcess | 
			[ aProcess terminate ] on: Error do: [ "ignore error" ] ].
	uniqueInstance := nil.! !

!GTEventRecorder class methodsFor: 'accessing' stamp: 'JurajKubelka 10/11/2015 14:42'!
uniqueInstance
	^ uniqueInstance ifNil: [ uniqueInstance := self new ].! !

!GTEventRecorder methodsFor: 'delivery' stamp: 'JurajKubelka 10/9/2015 11:28'!
activateDelivery
	^ delivery activate! !

!GTEventRecorder methodsFor: 'adding' stamp: 'JurajKubelka 10/9/2015 10:56'!
addCollector: aGTEventCollector
	self activateDelivery.
	^ collectors add: aGTEventCollector! !

!GTEventRecorder methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 21:20'!
announcer
	^ announcer! !

!GTEventRecorder methodsFor: 'testing' stamp: 'JurajKubelka 10/9/2015 14:49'!
canSendDiagnosticsAndUsageData
	^ privacy value! !

!GTEventRecorder methodsFor: 'delivery' stamp: 'JurajKubelka 10/9/2015 11:28'!
deactivateDelivery
	^ delivery deactivate! !

!GTEventRecorder methodsFor: 'delivery' stamp: 'JurajKubelka 10/9/2015 11:29'!
deliverNow
	delivery now! !

!GTEventRecorder methodsFor: 'accessing' stamp: 'JurajKubelka 10/9/2015 15:47'!
delivery
	"Testing purpose."
	^ delivery! !

!GTEventRecorder methodsFor: 'packing' stamp: 'JurajKubelka 10/9/2015 14:54'!
flush
	collectors do: #flush! !

!GTEventRecorder methodsFor: 'gt-inspector-extension' stamp: 'JurajKubelka 10/9/2015 16:40'!
gtInspectorItemsIn: composite
	<gtInspectorPresentationOrder: 1>
	^ collectors ifNotNil: [ 
			(collectors gtInspectorItemsIn: composite) ]! !

!GTEventRecorder methodsFor: 'initialization' stamp: 'JurajKubelka 10/10/2015 15:17'!
initialize
	super initialize.
	announcer := Announcer new.
	collectors := GTEventCollectors new.
	delivery := GTEventDelivery new.
	delivery recorder: self.
	packing := GTEventPacking ston.
	privacy := [ Privacy sendDiagnosticsAndUsageData ]! !

!GTEventRecorder methodsFor: 'testing' stamp: 'JurajKubelka 10/9/2015 10:44'!
isDeliveryActive
	^ delivery isActive! !

!GTEventRecorder methodsFor: 'testing' stamp: 'JurajKubelka 10/11/2015 16:15'!
isGlobalRecorder
	^ self class isGlobalRecorder: self! !

!GTEventRecorder methodsFor: 'convenient' stamp: 'JurajKubelka 10/9/2015 10:29'!
numberOfCollectors
	^ collectors size! !

!GTEventRecorder methodsFor: 'configuration' stamp: 'JurajKubelka 10/9/2015 11:32'!
offerDeliveryPermission
	delivery offerPermission! !

!GTEventRecorder methodsFor: 'configuration' stamp: 'JurajKubelka 10/9/2015 14:51'!
offerPrivacy
	"testing purpose"
	privacy := true! !

!GTEventRecorder methodsFor: 'packing' stamp: 'JurajKubelka 10/9/2015 16:24'!
pack
	self canSendDiagnosticsAndUsageData ifFalse: [ ^ self flush; yourself ].
	collectors do: [ :eachCollector | | bundle |
		bundle := packing pack: eachCollector.
		bundle data ifNotEmpty: [ delivery add: bundle ] ].! !

!GTEventRecorder methodsFor: 'removing' stamp: 'JurajKubelka 10/11/2015 15:52'!
removeCollector: aGTEventCollector 
	| removedCollector |
	removedCollector := collectors remove: aGTEventCollector.
	collectors size = 0 ifTrue: [ self deactivateDelivery ].
	^ removedCollector! !

!GTEventRecorder methodsFor: 'configuration' stamp: 'JurajKubelka 10/9/2015 11:24'!
withdrawDeliveryPermission
	delivery withdrawPermission! !

!GTEventRecorder methodsFor: 'configuration' stamp: 'JurajKubelka 10/9/2015 14:51'!
withdrawPrivacy
	"testing purpose"
	privacy := false! !

Object subclass: #GTEventRecorderSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Settings'!

GTEventRecorderSettings class
	instanceVariableNames: 'url'!

GTEventRecorderSettings class
	instanceVariableNames: 'url'!

!GTEventRecorderSettings class methodsFor: 'cleanup' stamp: 'JurajKubelka 10/11/2015 14:17'!
cleanUp
	"Clean settings."
	url := nil! !

!GTEventRecorderSettings class methodsFor: 'accessing' stamp: 'JurajKubelka 10/11/2015 14:13'!
stringUrl
	^ self url asString! !

!GTEventRecorderSettings class methodsFor: 'accessing' stamp: 'JurajKubelka 10/11/2015 14:13'!
stringUrl: aUrlString
	^ self url: aUrlString! !

!GTEventRecorderSettings class methodsFor: 'accessing' stamp: 'JurajKubelka 10/11/2015 14:12'!
url
	^ url ifNil: [ url := 'http://gc.dcc.uchile.cl.:8080/gt/events' asZnUrl ]! !

!GTEventRecorderSettings class methodsFor: 'accessing' stamp: 'JurajKubelka 10/11/2015 14:12'!
url: aZnUrl
	url := aZnUrl ifNotNil: [ aZnUrl asZnUrl ].! !

!GTEventRecorderSettings class methodsFor: 'settings' stamp: 'JurajKubelka 10/11/2015 14:14'!
urlSettingsOn: aBuilder 
	<systemsettings>	
	(aBuilder setting: #stringUrl)
		parent: #gt;
		target: self;
		description: 'The default URL for the Event Recorder server.' translated;
		label: 'Event Recorder URL address'
! !

Object subclass: #GlobalIdentifier
	instanceVariableNames: 'persistenceStrategy persistedInformation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Identifier'!

GlobalIdentifier class
	instanceVariableNames: 'uniqueInstance'!

!GlobalIdentifier commentStamp: 'AndreiChis 9/15/2015 11:54' prior: 0!
I keep global IDs that are used for tracking user activity, e.g. computer id. By default, you should access me by calling #uniqueInstance.

Responsibility:
The IDs that are important to store onto disk (and shared by all images) should be placed in persistedInformation instance variable. On other hand, if you do not want to store it onto disk, create a new instance variable. I can #loadPreferences and #savePreferences onto a disk.

I know computer ID and secret ID. Computer ID is a global UUID that is share among all the images. It is stored on a local disk. Secret ID is use for encrypting information, e.g., class names, method names. You can use #hashForText: method.

Collaborators: I do not collaborate with other classes. I only offer the basic IDs for other frameworks.

Public API and Key Messages

- computerUUID 
- ensureComputerUUID
- hashForText:
- loadPreferences 
- savePreferences.

Before using #computerUUID, you should call #ensureComputerUUID. It will update UUID from the disk or stores existing one if it is not stored yet. I behave like this as autonatically storing data to disk on image start-up leads to errors.

Internal Representation and Key Implementation Points.

    Instance Variables
	persistedInformation:		<Dictionary>
	preferences:		<FileReference>
!

GlobalIdentifier class
	instanceVariableNames: 'uniqueInstance'!

!GlobalIdentifier class methodsFor: 'cleanup' stamp: 'JurajKubelka 8/27/2015 10:44'!
cleanUp
	"Clean unique instance."	
	self reset.! !

!GlobalIdentifier class methodsFor: 'initialization' stamp: 'JurajKubelka 10/11/2015 16:28'!
initializeUniqueInstance
	uniqueInstance := self basicNew initialize.
	uniqueInstance ensure.! !

!GlobalIdentifier class methodsFor: 'instance creation' stamp: 'AndreiChis 9/15/2015 11:48'!
new
	"Users should not create instances of this class.
	Within the framework more instances are created when loading data and when testing."
	self shouldNotImplement! !

!GlobalIdentifier class methodsFor: 'initialize-release' stamp: 'JurajKubelka 8/27/2015 10:44'!
reset
	"self reset"
	uniqueInstance := nil! !

!GlobalIdentifier class methodsFor: 'accessing' stamp: 'JurajKubelka 10/11/2015 16:27'!
uniqueInstance
	"self uniqueInstance"
	uniqueInstance ifNil: [ self initializeUniqueInstance ].
	^ uniqueInstance! !

!GlobalIdentifier methodsFor: 'accessing' stamp: 'JurajKubelka 10/10/2015 21:23'!
computerUUID
	"This value identifies a user logged into the computer.
	Before calling #computerUUID method, you should call #ensure."
	^ persistedInformation at: #computerUUID! !

!GlobalIdentifier methodsFor: 'load and saving' stamp: 'JurajKubelka 10/10/2015 21:32'!
ensure
	self persistenceStrategy ensure: self persistedInformation! !

!GlobalIdentifier methodsFor: 'initialization' stamp: 'JurajKubelka 10/10/2015 21:47'!
initialize
	super initialize.
	"Dictionary contains all the values that we want to persist on disk."
	persistedInformation := Dictionary new.
	persistedInformation at: #computerUUID put: UUID new asString.
	persistedInformation at: #secretUUID put: UUID new asString.
	persistenceStrategy := GlobalIdentifierPersistence ston.
	persistenceStrategy previous: GlobalIdentifierPersistence fuel.! !

!GlobalIdentifier methodsFor: 'actions' stamp: 'JurajKubelka 10/10/2015 20:37'!
obfuscate: anObject
	"If you have an information that you want to obfuscate before sending,
	this is likely a good solution for you."
	^ anObject hash bitXor: self secretUUID hash! !

!GlobalIdentifier methodsFor: 'accessing' stamp: 'JurajKubelka 9/2/2015 12:14'!
persistedInformation
	^ persistedInformation! !

!GlobalIdentifier methodsFor: 'accessing' stamp: 'JurajKubelka 10/10/2015 16:52'!
persistenceStrategy
	^ persistenceStrategy! !

!GlobalIdentifier methodsFor: 'accessing' stamp: 'JurajKubelka 10/10/2015 16:52'!
persistenceStrategy: anObject
	persistenceStrategy := anObject! !

!GlobalIdentifier methodsFor: 'accessing' stamp: 'JurajKubelka 10/10/2015 21:23'!
secretUUID
	"This value can be used for obfuscating an information before sending it.
	See #obfuscate: method.
	Before calling #secretUUID method, you should call #ensure."
	^ persistedInformation at: #secretUUID! !

Object subclass: #GlobalIdentifierMerger
	instanceVariableNames: 'existing stored'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Identifier'!

!GlobalIdentifierMerger methodsFor: 'actions' stamp: 'JurajKubelka 10/10/2015 22:12'!
convertValues
	existing 
		at: #computerUUID 
		ifPresent: [ :aValue | existing at: #computerUUID put: aValue asString ]
		ifAbsent: [ "ignore" ].
	existing 
		at: #secretUUID
		ifPresent: [ :aValue | existing at: #secretUUID put: aValue asString ]
		ifAbsent: [ "ignore" ].! !

!GlobalIdentifierMerger methodsFor: 'accessing' stamp: 'JurajKubelka 10/10/2015 19:31'!
existing
	^ existing! !

!GlobalIdentifierMerger methodsFor: 'accessing' stamp: 'JurajKubelka 10/10/2015 19:31'!
existing: anObject
	existing := anObject! !

!GlobalIdentifierMerger methodsFor: 'actions' stamp: 'JurajKubelka 10/10/2015 20:13'!
merge
	"If UUIDs are different, it is likely different user and we should use
	localy stored settings. If the UUIDs are same, we keep settings of the image.
	
	It returns true if existing dictionary is changed."
	^ ((existing at: #computerUUID ifAbsent: nil) = (stored at: #computerUUID ifAbsent: nil)
		or: [ (stored includesKey: #computerUUID) not ])
			ifTrue: [ self mergeSameComputer ]
			ifFalse: [ self mergeDifferentComputer ]! !

!GlobalIdentifierMerger methodsFor: 'actions' stamp: 'JurajKubelka 10/10/2015 22:07'!
mergeDifferentComputer
	"It puts all stored values into existing dictionary."
	stored keysAndValuesDo: [ :eachKey :eachValue |
		existing at: eachKey put: eachValue ].
	self convertValues.
	^ true! !

!GlobalIdentifierMerger methodsFor: 'actions' stamp: 'JurajKubelka 10/10/2015 22:13'!
mergeSameComputer
	"It add into existing dictionary keys that are included in the stored dictionary,
	but are missing in the existing dictionary. Useful when a new version
	adds new configuration values that should be saved too.
	
	It returns true if existing dictionary is changed."
	| difference |
	difference := stored keys difference: existing keys.
	difference ifEmpty: [ ^ false ].
	difference do: [ :eachKey |
		existing at: eachKey put: (stored at: eachKey) ].
	self convertValues.
	^ true! !

!GlobalIdentifierMerger methodsFor: 'accessing' stamp: 'JurajKubelka 10/10/2015 19:31'!
stored
	^ stored! !

!GlobalIdentifierMerger methodsFor: 'accessing' stamp: 'JurajKubelka 10/10/2015 19:31'!
stored: anObject
	stored := anObject! !

Object subclass: #GlobalIdentifierPersistence
	instanceVariableNames: 'preferences previousPersistence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Identifier'!

GlobalIdentifierPersistence subclass: #GlobalIdentifierFuelPersistence
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Identifier'!

!GlobalIdentifierFuelPersistence methodsFor: 'configuration' stamp: 'JurajKubelka 10/10/2015 21:07'!
fileName 
	^ 'org.pharo.gt.spotter.event.recorder.fuel'! !

!GlobalIdentifierFuelPersistence methodsFor: 'load and saving' stamp: 'JurajKubelka 10/10/2015 20:17'!
load
	^ FLMaterializer materializeFromFileNamed: self preferences! !

!GlobalIdentifierFuelPersistence methodsFor: 'load and saving' stamp: 'JurajKubelka 10/10/2015 20:31'!
save: aDictionary into: aWriteStream
	aWriteStream binary.
	[ FLSerializer serialize: aDictionary on: aWriteStream ]
		on: Error
		do: [ :anError | "ignore" ]! !

!GlobalIdentifierPersistence class methodsFor: 'instance creation' stamp: 'JurajKubelka 10/10/2015 18:46'!
fuel
	^ GlobalIdentifierFuelPersistence new! !

!GlobalIdentifierPersistence class methodsFor: 'instance creation' stamp: 'JurajKubelka 10/10/2015 20:58'!
ston
	^ GlobalIdentifierStonPersistence new! !

!GlobalIdentifierPersistence methodsFor: 'configuration' stamp: 'JurajKubelka 10/10/2015 21:08'!
defaultPreferences
	^ FileLocator preferences / self fileName! !

!GlobalIdentifierPersistence methodsFor: 'operations' stamp: 'JurajKubelka 10/10/2015 19:13'!
delete
	"self deletePreferences"
	[ self preferences ensureDelete ]
	on: Error do: [ "ignore" ]! !

!GlobalIdentifierPersistence methodsFor: 'load and saving' stamp: 'JurajKubelka 10/10/2015 21:42'!
ensure: existingDictionary
	"It proceeds all backward compatibility work."
	self shouldCallPreviousPersistence ifTrue: [ 
		previousPersistence ensure: existingDictionary ].
	self load: existingDictionary! !

!GlobalIdentifierPersistence methodsFor: 'operations' stamp: 'JurajKubelka 10/10/2015 19:14'!
ensureDirectory
	self preferences parent ensureCreateDirectory ! !

!GlobalIdentifierPersistence methodsFor: 'configuration' stamp: 'JurajKubelka 10/10/2015 21:10'!
fileName
	^ self subclassResponsibility! !

!GlobalIdentifierPersistence methodsFor: 'load and saving' stamp: 'JurajKubelka 10/10/2015 20:18'!
load
	"It loads and returns stored dictionary."
	^ self subclassResponsibility! !

!GlobalIdentifierPersistence methodsFor: 'load and saving' stamp: 'JurajKubelka 10/10/2015 20:20'!
load: existingDictionary
	"It loads stored information into existingDictionary."
	self preferences exists ifFalse: [
		"This is a new computer, so we define new computer UUID.
		User still has to agree about sending data if it is not has been done yet."
		^ self save: existingDictionary ].
	[ (self mergeExisting: existingDictionary stored: self load)
			ifTrue: [ self save: existingDictionary ].
	] on: Error do: [ 
		"Preferences likely contains a different settings version, so we store the actual one.
		We should keep the preferences as stable as possible."
		self save: existingDictionary ]! !

!GlobalIdentifierPersistence methodsFor: 'merging' stamp: 'JurajKubelka 10/10/2015 20:17'!
mergeExisting: existingDictionary stored: storedDictionary
	^ GlobalIdentifierMerger new
			existing: existingDictionary;
			stored: storedDictionary;
			merge! !

!GlobalIdentifierPersistence methodsFor: 'accessing' stamp: 'JurajKubelka 10/10/2015 21:08'!
preferences
	^ preferences ifNil: [ preferences := self defaultPreferences ]! !

!GlobalIdentifierPersistence methodsFor: 'accessing' stamp: 'JurajKubelka 10/10/2015 16:39'!
preferences: anObject
	preferences := anObject! !

!GlobalIdentifierPersistence methodsFor: 'accessing' stamp: 'JurajKubelka 10/10/2015 21:45'!
previous
	^ previousPersistence! !

!GlobalIdentifierPersistence methodsFor: 'accessing' stamp: 'JurajKubelka 10/10/2015 21:45'!
previous: aGlobalIdentifierPersistence
	previousPersistence := aGlobalIdentifierPersistence! !

!GlobalIdentifierPersistence methodsFor: 'load and saving' stamp: 'JurajKubelka 10/10/2015 20:29'!
save: aDictionary
	self delete.
	self ensureDirectory.
	self preferences writeStreamDo: [ :aPreferenceStream | 
			self save: aDictionary into: aPreferenceStream ]! !

!GlobalIdentifierPersistence methodsFor: 'load and saving' stamp: 'JurajKubelka 10/10/2015 20:32'!
save: aDictionary into: aWriteStream
	"Saves aDictionary into aWriteStream"
	self subclassResponsibility! !

!GlobalIdentifierPersistence methodsFor: 'testing' stamp: 'JurajKubelka 10/10/2015 21:43'!
shouldCallPreviousPersistence
	^ self preferences exists not and: [ previousPersistence notNil ]! !

GlobalIdentifierPersistence subclass: #GlobalIdentifierStonPersistence
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Identifier'!

!GlobalIdentifierStonPersistence methodsFor: 'configuration' stamp: 'JurajKubelka 10/10/2015 21:07'!
fileName
	^ 'org.pharo.global-identifiers.ston'! !

!GlobalIdentifierStonPersistence methodsFor: 'load and saving' stamp: 'JurajKubelka 10/10/2015 21:15'!
load
	^ self preferences readStreamDo: [ :aReadStream |
			STON fromStream: aReadStream ]! !

!GlobalIdentifierStonPersistence methodsFor: 'load and saving' stamp: 'JurajKubelka 10/10/2015 21:02'!
save: aDictionary into: aWriteStream
	STON put: aDictionary onStreamPretty: aWriteStream! !

Object subclass: #Privacy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-EventRecorder-Privacy'!

Privacy class
	instanceVariableNames: 'sendDiagnosticsAndUsageData'!

!Privacy commentStamp: 'JurajKubelka 9/2/2015 12:56' prior: 0!
I represent basic privacy question about collecting user activities and other data that helps to improve Pharo and related tools.

Responsibility: 
I keep information about sending diagnostic and usage data. 

Collaborators:
I only keep the privacy information. All services that collects diagnostic and usage data should do it only if #sendDiagnosticsAndUsageData is true. 

If you want to add more specific settings related to privacy, you can put it to the privacy group.

Public API and Key Messages

- sendDiagnosticsAndUsageData   
!

Privacy class
	instanceVariableNames: 'sendDiagnosticsAndUsageData'!

!Privacy class methodsFor: 'cleanup' stamp: 'JurajKubelka 10/11/2015 14:15'!
cleanUp
	"Clean settings."
	sendDiagnosticsAndUsageData := nil.! !

!Privacy class methodsFor: 'settings' stamp: 'JurajKubelka 6/18/2015 17:05'!
privacySettingsOn: aBuilder
	<systemsettings>
	(aBuilder group: #privacy)
		label: 'Privacy';
		noOrdering;
		description: 'All settings concerned with privacy'! !

!Privacy class methodsFor: 'accessing' stamp: 'JurajKubelka 6/17/2015 16:05'!
sendDiagnosticsAndUsageData
	^ sendDiagnosticsAndUsageData ifNil: [ sendDiagnosticsAndUsageData := true ]! !

!Privacy class methodsFor: 'accessing' stamp: 'JurajKubelka 6/17/2015 16:05'!
sendDiagnosticsAndUsageData: aBoolean
	sendDiagnosticsAndUsageData := aBoolean! !

!Privacy class methodsFor: 'settings' stamp: 'JurajKubelka 6/18/2015 20:01'!
sendDiagnosticsAndUsageUsageDataSettingsOn: aBuilder
	<systemsettings>
	(aBuilder setting: #sendDiagnosticsAndUsageData)
		label: 'Send diagnostics and usage data';
		noOrdering;
		description: 'Help Pharo community improve its products and services by automatically sending diagnostic and usage data.';
		parent: #privacy! !
